/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 *
 * SQL tutorial: http://www.w3schools.com/sql/
 */

package javadb;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 *
 * @author Kuba
 */
public class DbTabulka {
    private int pocetStudentu;

    public DbTabulka(){
        pocetStudentu = 0;
    }

    public void zvysPocetStudentu(){
        pocetStudentu++;
    }

    public void snizPocetStudentu(){
        pocetStudentu--;
    }

    public void vytvorTabulku(DbConnection dbConn){
        //--- definuje tabulku, ktera se jmenuje "studenti" a ma 4 sloupce
        //--- Student_ID
        //--- Jmeno
        //--- Prijmeni
        //--- Prumer (zrejme studijni)
        String createString = "CREATE TABLE studenti("
                       + "student_id INTEGER, "
                       + "jmeno VARCHAR(10),"
                       + "prijmeni VARCHAR(30),"
                       + "prumer  FLOAT4)";
        String deleteString = "DELETE * FROM studenti";
		try {
            //--- VYTVORENI TABULKY
            dbConn.con.setAutoCommit(true);
            Statement stmt = dbConn.con.createStatement();
	   		stmt.executeUpdate(createString);
            System.out.println("Tabulka studentu vytvorena");
            stmt.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
    }

    public void pridejStudenty(DbConnection dbConn){
        try{
            boolean autoBefore = dbConn.con.getAutoCommit();
            dbConn.con.setAutoCommit(false);
            PreparedStatement st = dbConn.con.prepareStatement("INSERT INTO studenti(student_id, jmeno, prijmeni, prumer) VALUES(?,?,?,?)");
            //--- jeden student
            st.setInt(1,pocetStudentu);
            st.setString(2,"Franta");
            st.setString(3,"Kulhanu");
            st.setDouble(4,1.6);
            st.execute();
            zvysPocetStudentu();
            //--- druhy student
            st.setInt(1,pocetStudentu);
            st.setString(2,"Pepa");
            st.setString(3,"Zdepa");
            st.setDouble(4,1.1);
            st.execute();
            zvysPocetStudentu();
            //--- treti student
            st.setInt(1,pocetStudentu);
            st.setString(2,"Anna");
            st.setString(3,"Vdana");
            st.setDouble(4,1.3);
            st.execute();
            zvysPocetStudentu();
            //---
            dbConn.con.commit();    //--- ted se to teprve fyzicky prida do db
            dbConn.con.setAutoCommit(autoBefore);
            st.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
    }

    public void pridejStudentaUplny(DbConnection dbConn){
        String createString = "INSERT INTO studenti(student_id, jmeno, prijmeni, prumer) "
                       + "VALUES ("
                       + pocetStudentu + ", "
                       + "'Jarda', 'Carda', 2.3)";
		try {
            Statement stmt = dbConn.con.createStatement();
	   		stmt.executeUpdate(createString);
            zvysPocetStudentu();
            // ukonceni prace
            stmt.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
    }

    public void pridejStudentaNeuplny(DbConnection dbConn){
        String createString = "INSERT INTO studenti(student_id, jmeno, prijmeni) "
                       + "VALUES ("
                       + pocetStudentu + ", "
                       + "'Marie', 'Pilna')";
		try {
            Statement stmt = dbConn.con.createStatement();
	   		stmt.executeUpdate(createString);
            zvysPocetStudentu();
            stmt.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
    }

    public void upravZaznam(DbConnection dbConn){
        //--- UPDATE table_name
        //--- SET column1=value, column2=value2,...
        //--- WHERE some_column=some_value
        String createString = "UPDATE studenti "
                       + "SET prumer=3.0 "
                       + "Where prijmeni='Kulhanu'";
		try {
            Statement stmt = dbConn.con.createStatement();
	   		stmt.executeUpdate(createString);
            stmt.close();
		} catch(SQLException ex) {
			System.err.println("SQLException: " + ex.getMessage());
		}
    }

    public void vypisStudenty(DbConnection dbConn) {

        try {
            Statement stmt = dbConn.con.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT jmeno, prijmeni FROM studenti");
            System.out.println("\nV tabulce jsou tito studenti:");
            while (rs.next()) {
                System.out.println(rs.getString("jmeno") + " " + rs.getString("prijmeni"));
            }
        } catch (SQLException ex) {
            System.err.println("SQLException: " + ex.getMessage());
        }
    }

    public void vypisStudentySetridene(DbConnection dbConn) {

        try {
            Statement stmt = dbConn.con.createStatement();
            ResultSet rs = stmt.executeQuery("SELECT jmeno, prijmeni FROM studenti ORDER BY prijmeni ASC");
            System.out.println("\nVypis studentu podle prijmeni:");
            while (rs.next()) {
                System.out.println(rs.getString("jmeno") + " " + rs.getString("prijmeni"));
            }
            //---
            rs = stmt.executeQuery("SELECT jmeno, prijmeni, prumer FROM studenti ORDER BY prumer ASC");
            System.out.println("\nVypis studentu podle prumeru:");
            while (rs.next()) {
                System.out.println(rs.getString("jmeno") + " " + rs.getString("prijmeni") + " " + rs.getString("prumer"));
            }
            //---
            rs = stmt.executeQuery("SELECT student_id, jmeno, prijmeni, prumer FROM studenti WHERE prumer<1.5 AND student_id<=3");
            System.out.println("\nVypis studentu s prumerem do 1.5 a Id<4:");
            while (rs.next()) {
                System.out.println(rs.getString("student_id") + " " + rs.getString("jmeno") + " " + rs.getString("prijmeni") + " " + rs.getString("prumer"));
            }
        } catch (SQLException ex) {
            System.err.println("SQLException: " + ex.getMessage());
        }
    }

    public static void main(String[] args) throws SQLException, ClassNotFoundException {

        //--- vytvori spojeni s databazi
        DbConnection dbConn = new DbConnection();

        //--- vytvor tabulku
        DbTabulka tabulka = new DbTabulka();
        tabulka.vytvorTabulku(dbConn);

        //--- pridej studenty
        tabulka.pridejStudentaUplny(dbConn);
        tabulka.pridejStudentaNeuplny(dbConn);
        tabulka.pridejStudenty(dbConn);

        //--- vypis studenty
        tabulka.vypisStudenty(dbConn);
        tabulka.vypisStudentySetridene(dbConn);

        //--- uprav zaznam
        tabulka.upravZaznam(dbConn);
        tabulka.vypisStudentySetridene(dbConn);

        //--- ukonceni prace
        dbConn.closeConnection();
    }
}
